# -*- coding: utf-8 -*-

"""

Este es el algotirmo de Dijkstra implementado mediante colas de prioridad.
Para representar la cola de prioridad se utiliza un montículo.

"""

# Fuente http://code.activestate.com/recipes/119466/
# Autor: Connelly Barnes
# Licencia: MIT License

import heapq

def shortest_path(G, start, end):
        
   def flatten(L):       # Flatten linked list of form [0,[1,[2,[]]]]
      while len(L) > 0:
         yield L[0]
         L = L[1]

   q = [(0, start, ())]  # Heap of (cost, path_head, path_rest).
   visited = set()       # Visited vertices.
   while True:
      (cost, v1, path) = heapq.heappop(q)
      if v1 not in visited:
         visited.add(v1)
         if v1 == end:
            return list(flatten(path))[::-1] + [v1]
         path = (v1, path)
         for (v2, cost2) in G[v1].iteritems():
            if v2 not in visited:
               heapq.heappush(q, (cost + cost2, v2, path))