# -*- coding: utf-8 -*-

#Load models, textures, sounds, and code.
from direct.showbase.Loader import Loader

from direct.showbase.DirectObject import DirectObject

from direct.gui.OnscreenText import OnscreenText

# para cargar imagenes
from direct.gui.OnscreenImage import OnscreenImage

from pandac.PandaModules import TextNode

from pandac.PandaModules import NodePath

# This next one enable the transparency and is easily overlooked
from pandac.PandaModules import TransparencyAttrib 
from pandac.PandaModules import TextureStage
from pandac.PandaModules import TexGenAttrib
from pandac.PandaModules import Texture

from pandac.PandaModules import CollisionTraverser
from pandac.PandaModules import CollisionHandlerEvent
from pandac.PandaModules import CollisionNode
from pandac.PandaModules import CollisionSphere
from pandac.PandaModules import CollisionTube
from pandac.PandaModules import CollisionSegment
from pandac.PandaModules import CollisionPlane
from pandac.PandaModules import BitMask32

from pandac.PandaModules import Plane
from pandac.PandaModules import VBase3
from pandac.PandaModules import Point3
from pandac.PandaModules import Vec3

from direct.task.Task import Task

from random import randint,shuffle
from math import hypot,atan,degrees,radians,sin,cos
import re

from escalas import Escalas
        
# FLECHA DE DIRECCION EN PANTALLA
#class Brujula:
#    
#    def __init__(self,nodo,pos):
#        
#        self.brujula = OnscreenImage(image="imagenes/brujula.png",parent=nodo)
#        self.brujula.reparentTo(nodo)
#        self.brujula.setScale(0.2)
#       
#        self.brujula.setPos(pos[0],0,pos[1])
#        
#        self.brujula.setTransparency(TransparencyAttrib.MAlpha)
#        self.brujula.setColor(1,1,1,0.7)
#    
#    def setRoll(self,r):
#        self.brujula.setR(r-90)
#        
#    def __del__(self):
#        self.brujula.removeNode()
#    

# FLECHA DE DIRECCION SOBRE EL SUELO     
class Flecha():
    
    # letrero para indicar la direccion
    class Id():
        
        def __init__(self,parent):
            
            texto = TextNode('texto_flecha')
            texto.setText('')
            texto.setAlign( TextNode.ACenter )
            texto.setTextColor(0,0,0,0.9)
            texto.setCardColor(1, 1, 1, 0.7)
            texto.setCardAsMargin(0, 0, 0, 0)
            texto.setCardDecal(True)
            
            self.TNodePath = NodePath(texto)
            self.TNodePath.setBin("fixed", 150)
            self.TNodePath.reparentTo(parent)
            
        def set(self,name,pos):
            
            self.TNodePath.setPos(pos)
            self.TNodePath.setZ(Escalas['m-px']*2)
            self.TNodePath.node().setText(name)
                
        def Orientar(self):
            dist = (self.TNodePath.getPos() - base.camera.getPos()).length()
            if dist < Escalas['m-px']*15:
                self.TNodePath.setScale(7)
            elif dist > Escalas['m-px']*60:
                self.TNodePath.setScale((Escalas['m-px']*60)*7/(Escalas['m-px']*15))
            else:
                self.TNodePath.setScale(dist*7/(Escalas['m-px']*15))
                
                
            self.TNodePath.lookAt(base.camera)
            self.TNodePath.setH(self.TNodePath.getH()+180)
            self.TNodePath.setP(-50)
            
        def __del__(self):
            self.TNodePath.removeNode()

    # FLECHA DE DIRECCION EN PANTALLA
    class FlechaMini:
        
        def __init__(self,parent):
            
            self.flecha = OnscreenImage(image="imagenes/flecha_verde.png",parent=parent)
            self.flecha.reparentTo(parent)
            self.flecha.setScale(0.040)
           
            self.flecha.setPos(Point3(-0.75,0,0.88))
            
            self.flecha.setTransparency(TransparencyAttrib.MAlpha)
            #self.flecha.setColor(1,1,1,0.7)
     
        def setHeading(self,pos1,pos2,pos3):
            
            vx = pos2[0] - pos1[0]
            vy = pos2[1] - pos1[1]
            
            if(vx == 0):
                anguloDegrees = 90
                #self.setHeading(90)
            elif(vy == 0):
                anguloDegrees = 0
                #self.setHeading(0)
            else:
                angulo = abs( vy / vx ) 
                anguloRad = atan(angulo)
                anguloDegrees = degrees(anguloRad)
            # el calculo de los angulos se puede trasladar a cuando
            # a cuando se direge a su nuevo destino
            if vx<0 and vy>0: # segundo cuadrante
                anguloDegrees = 180 - anguloDegrees
            elif vx<0 and vy<0: # tercer cuadrante
                anguloDegrees = anguloDegrees + 180
            elif vx>0 and vy<0: # cuarto cuadrante
                anguloDegrees = anguloDegrees * (-1)
            
            alpha = anguloDegrees
            
            vx = pos3[0] - pos2[0]
            vy = pos3[1] - pos2[1]
            
            if(vx == 0):
                anguloDegrees = 90
                #self.setHeading(90)
            elif(vy == 0):
                anguloDegrees = 0
                #self.setHeading(0)
            else:
                angulo = abs( vy / vx ) 
                anguloRad = atan(angulo)
                anguloDegrees = degrees(anguloRad)
            # el calculo de los angulos se puede trasladar a cuando
            # a cuando se direge a su nuevo destino
            if vx<0 and vy>0: # segundo cuadrante
                anguloDegrees = 180 - anguloDegrees
            elif vx<0 and vy<0: # tercer cuadrante
                anguloDegrees = anguloDegrees + 180
            elif vx>0 and vy<0: # cuarto cuadrante
                anguloDegrees = anguloDegrees * (-1)
            
            beta = anguloDegrees
            
            self.flecha.setR(360-(beta-alpha))
        
        def setRoll(self,r):
            self.flecha.setR(360-r)
            
        def __del__(self):
            self.flecha.removeNode()    
        
    # Clase Fecha
    def __init__(self,parent,parent2d):
        
        # nodo hacia el que se orienta la flecha
        self.destino = NodePath('nodo_destino')
           
        # flecha de dirección sobre el suelo
        self.flecha = OnscreenImage(image="imagenes/flecha_verde.png",parent=parent)
        self.flecha.setScale(Escalas['m-px']*1.5)
        self.flecha.setTransparency(TransparencyAttrib.MAlpha) # crea la transparencia
        self.flecha.setColor(1,1,1,0.8) # crea el color de transparencia
        self.flecha.setBin("fixed", 110)
        self.flecha.reparentTo(parent)
        
        # direccion del vehiculo
        self.texto_cruce = OnscreenText(text='',
                                       pos=(-1.3,0.93),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = loader.loadFont('fuentes/FreeSansBold.ttf'),
                                       parent=parent2d,
                                       mayChange=True)
        
        # texto 3d indicando la dirección del cruce
        self.id = self.Id(parent)
        # flecha en pantalla que indica la direccion a tomar
        self.flecha_mini = self.FlechaMini(parent2d)
        
    def ProximoCruce(self,nodo_anterior,nodo):
        
        # obtiene la lista de adyacencia evitando retroceso
        self.listaAdyacentes = nodo.getListaSiguientes(nodo_anterior)
        
        self.nodo_anterior = nodo_anterior
        # mientras solo exista una única posibilidad
        while self.listaAdyacentes.__len__() == 1:
            self.nodo_anterior = nodo
            nodo = self.listaAdyacentes[0]
            self.listaAdyacentes = nodo.getListaSiguientes(self.nodo_anterior)
        
        # si hay un proximo cruce
        if self.listaAdyacentes.__len__()>0:
            
            # guada el nodo en que se recoloca la flecha
            self.nodo = nodo
            
            # coloca la flecha en el cruce
            self.setPos(nodo.getPos())
            
            # lista de angulos de la lista de posibles destinos (angulo, nodo)
            self.AngulosDestinos = []
            for ad in self.listaAdyacentes:
                self.AngulosDestinos.append((self.CalcularAngulo(self.nodo.getPos(), ad.getPos()),
                                             ad))      
        
            # ordena en funcion del angulo
            self.AngulosDestinos.sort(cmp=self.cmp)
          
            # indide del destino seleccionado
            self.seleccion = 0
            # orienta la flecha al destino por defecto
            self.setDestino(self.AngulosDestinos[self.seleccion][1].getPos())
            self.Orientar()
      
            self.texto_cruce.node().setText('Próximo cruce en \'' + \
                                           self.getNombreTramo(self.nodo_anterior,self.nodo) + \
                                           '\', ' + \
                                           'destino \'' + \
                                           self.getNombreTramo(self.nodo,
                                                               self.AngulosDestinos[self.seleccion][1]) + \
                                           '\'\n' + \
                                           'Próximo giro hacia:')
      
            self.id.set(self.getNombreTramo(self.nodo,
                                            self.AngulosDestinos[self.seleccion][1]),
                        self.nodo.getPos())
            
            self.flecha_mini.setHeading(self.nodo_anterior.getPos(),
                                        self.nodo.getPos(),
                                        self.AngulosDestinos[self.seleccion][1].getPos())
      
    # funcion de comparacion
    def cmp(self,a,b):
        # compara los angulos, tupla(angulo,nodo)
        return  int(a[0]-b[0])
      
    def DestinoAnterior(self,mapa):
        self.seleccion = (self.seleccion-1)%self.AngulosDestinos.__len__()
        self.setDestino(self.AngulosDestinos[self.seleccion][1].getPos())
        self.Orientar()
      
        self.texto_cruce.node().setText('Próximo cruce en \'' + \
                                           self.getNombreTramo(self.nodo_anterior,self.nodo) + \
                                           '\', ' + \
                                           'destino \'' + \
                                           self.getNombreTramo(self.nodo,
                                                               self.AngulosDestinos[self.seleccion][1]) + \
                                           '\'\n' + \
                                           'Próximo giro hacia:')
      
        # letrero
        self.id.set(self.getNombreTramo(self.nodo,
                                            self.AngulosDestinos[self.seleccion][1]),
                        self.nodo.getPos())
        
        
        # flecha mini en pantalla
        self.flecha_mini.setHeading(self.nodo_anterior.getPos(),
                                    self.nodo.getPos(),
                                    self.AngulosDestinos[self.seleccion][1].getPos())
      
    def DestinoSiguiente(self,mapa):
        self.seleccion = (self.seleccion+1)%self.AngulosDestinos.__len__()  
        self.setDestino(self.AngulosDestinos[self.seleccion][1].getPos())
        self.Orientar()
        
        self.texto_cruce.node().setText('Próximo cruce en \'' + \
                                           self.getNombreTramo(self.nodo_anterior,self.nodo) + \
                                           '\', ' + \
                                           'destino \'' + \
                                           self.getNombreTramo(self.nodo,
                                                               self.AngulosDestinos[self.seleccion][1]) + \
                                           '\'\n' + \
                                           'Próximo giro hacia:')
        
        # letrero
        self.id.set(self.getNombreTramo(self.nodo,
                                            self.AngulosDestinos[self.seleccion][1]),
                        self.nodo.getPos())
        
        # flecha mini en pantalla
        self.flecha_mini.setHeading(self.nodo_anterior.getPos(),
                                    self.nodo.getPos(),
                                    self.AngulosDestinos[self.seleccion][1].getPos())
    
    # recoloca el nodo hace el que se orienta la Flecha 
    def setDestino(self,pos):
        self.destino.setPos(pos)
      
    # establece el nodo de destino manualmente    
    def setNodoDestino(self,nodo):
        self.seleccion = 0
        self.AngulosDestinos = [(0,nodo)]
      
    # devuelve el id del nodo seleccionado
    def getNodoDestino(self):
        return self.AngulosDestinos[self.seleccion][1]
    
    # devuelve el nodo sobre el que se ubica la flecha
    def getNodo(self):
        return self.nodo
    
    # ubica la flecha en una posicion
    def setPos(self,pos):
        self.flecha.setPos(pos)
    
    # reorienta la flecha
    def Orientar(self):
        self.flecha.lookAt(self.destino)
        self.flecha.setP(-90)
    
    def OrientarLetrero(self,task):
        self.id.Orientar()
        return Task.cont
    
    def CalcularHeading(self,pos1,pos2):
        
        self.setHeading(self.CalcularAngulo(pos1, pos2) )
    
    # calcula el angulo entre dos posiciones
    def CalcularAngulo(self,pos1,pos2):
        
        vx = pos2[0] - pos1[0]
        vy = pos2[1] - pos1[1]
        
        if(vx == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vy == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vy / vx ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vx<0 and vy>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vx<0 and vy<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vx>0 and vy<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        return anguloDegrees%360
    
    # dados dos nodos devuelve el nombre de way al que pertenecen ambos
    def getNombreTramo(self,nodo,nodo_siguiente):
        
        for i in nodo.getListaWays():
            for j in nodo_siguiente.getListaWays():
                # busca el way en común
                if i == j:
                    return i.getName()
    
    # orienta la flecha
    def setHeading(self,h):
        self.flecha.setH(h-90)
    
    def getHeading(self):
        return self.flecha.getH()
        
    def __del__(self):
        self.flecha.removeNode()
        
        
     
class Vehiculo:
    
    # @param parent: nodo padre del vehiculo
    # @param incial: nodo de salida inicio del vehiculo
    # @param pos_inicial: posicion de salida del vehiculo
    # @param es_jugador: 1-> Es el vehiculo del jugador, 0-> otro caso
    # @param num: numero identificativo del vehiculo, unico, usado para las colisiones 
    def __init__(self,parent,nodo_inicial,pos_inicial=VBase3(0,0,0),es_jugador=0,num=0):
        
        # carga el modelo del vehiculo
        self.coche = loader.loadModel('modelos/carnsx')
        # escala para ajustarlo a la carretera
        self.coche.setScale(Escalas['m-px']*1.5/3)
        
        """ transparencia del vehiculo
        self.coche.setTransparency(True)
        self.coche.setColor(1,1,1,.5) 
        """
        
        # TEXTURA
        # establece el colo del vehiculo
        if es_jugador == 1:
            textura='modelos/carnsx.png'
        else:
            textura_select = randint(1,3)
            if textura_select == 1:
                textura = 'modelos/carnsx-green.png'
            if textura_select == 2:
                textura = 'modelos/carnsx-blue.png'
            if textura_select == 3:
                textura = 'modelos/carnsx-yellow.png'
        
        # establece la textura(color) del coche
        text = loader.loadTexture(textura)
        self.coche.find('**/body/body').setTexture(text, 1)
        self.coche.find('**/body/polySurface1').setTexture(text, 1)
        self.coche.find('**/body/polySurface2').setTexture(text, 1)
        #self.coche.setTexGen(TextureStage.getDefault(), TexGenAttrib.MWorldNormal)   
        
        # PRIORRIDAD DE RENDERIZADO
        # para que se vea por encima del mapa
        prioridad = 200
        self.coche.setBin("fixed", prioridad)
        self.coche.reparentTo(parent)
                
        # CONFIGURACION INCIAL DEL VEHICULO
        
        # id del nodo desde el que partio el vehiculo
        self.nodo_origen = nodo_inicial
        # id del nodo hacia el cual se dirige el vehiculo
        self.nodo_destino = nodo_inicial
        # id del nodo del sigiente destino
        self.nodo_sig_destino = nodo_inicial
        
        # posicion inicial del mapa
        self.coche.setPos(pos_inicial)
        # posicion VBase3 de destino del vehiculo
        self.destino = pos_inicial
        
        
        # indica si el vehiculo ha llegado a su destino
        self.ha_llegado = True
        
        # indica si el vehiculo ha sido parado
        self.esta_parado = False
        
        # orientacion del vehiculo
        self.headingRad = None
        # el objeto egg esta en angulo  270
        self.setHeading(0)
        #self.CalcularHeading()
        
        # MOVIMIENTO
        
        # velocidad
        self.velocidad = 0
        self.velMax = Escalas['kmh-pxs']*0
        # aceleracion
        self.aceleracion = Escalas['m-px']*4.2
        
        # COLISIONES
        self.cNodeEsfera = CollisionNode( 'morro_'+str(num) )
        #self.cNodeEsfera.addSolid( CollisionSphere(0,-2,0.5,1) )
#        self.cNodeEsfera.addSolid(CollisionSphere(0,-2,0.5,1))
        self.cNodeEsfera.addSolid( CollisionSegment(0,-3.1,0.5,0,-3.2,0.5) )
        self.cNodeEsfera.setFromCollideMask(BitMask32(0x02))
        self.cNodeEsfera.setIntoCollideMask(BitMask32(0x10))
        self.cNodePathEsfera = self.coche.attachNewNode(self.cNodeEsfera)
        
        # envuelve todo el el vehiculo
        self.cNodeTubo= CollisionNode( 'tubo_'+str(num) )
        self.cNodeTubo.addSolid( CollisionTube(0, -1.8, 0.5, 0, 1.8, 0.5, 1.2) )
        self.cNodeTubo.setFromCollideMask(BitMask32(0x11))
        self.cNodeTubo.setIntoCollideMask(BitMask32(0x02))
        self.cNodePathTubo = self.coche.attachNewNode(self.cNodeTubo)
        
        # nodo de colision del vehiculo para el destino
        self.cNodeCoche = CollisionNode( 'coche_'+str(num) )
        self.cNodeCoche.addSolid( CollisionSphere(0,-0.5,-1.5,0.8) )
        self.cNodeCoche.setFromCollideMask(BitMask32(0x05))
        self.cNodeCoche.setIntoCollideMask(BitMask32(0x15))
        self.cNodePathCoche = self.coche.attachNewNode(self.cNodeCoche)
#        self.cNodePathCoche.show()
        
        # nodo de colision situado en la posicion de destino
        self.cNodeDestino = CollisionNode( 'destino_'+str(num) )
        self.cNodeDestino.addSolid( CollisionSegment(0,0,-1.4,0,0,-1.6) )
        self.cNodeDestino.setFromCollideMask(BitMask32(0x15))
        self.cNodeDestino.setIntoCollideMask(BitMask32(0x02))
        self.cNodePathDestino = parent.attachNewNode(self.cNodeDestino)
        # este nodepath no esta unido al vehiculo por lo que necesita aplicarle la escala
        self.cNodePathDestino.setScale(Escalas['m-px']*1.5/3)
#        self.cNodePathDestino.show() 
#        self.cNodePathDestino.setPos(pos_inicial)
        
        # vector con los identificadores de los vehiculos con los que ha colisionado
        self.choques = []
        
    
    # COLISIONES
    
    def addColliderHand(self,collider):
        base.cTrav.addCollider(self.cNodePathEsfera,collider)
        base.cTrav.addCollider(self.cNodePathDestino,collider)
    
    def setCollDestino(self,Eventos,func):
        # el segmento(from) colision con el tubo(into)
        Eventos.accept(self.cNodePathDestino.getName()+'-into-'+self.cNodePathCoche.getName(),func)
  
    def delCollDestino(self,Eventos):
        Eventos.ignore(self.cNodePathDestino.getName()+'-into-'+self.cNodePathCoche.getName())
  
    def setCollVehiculo(self,Eventos,func1,func2,cNodePath):
        # evento para la colision
        Eventos.accept(self.cNodePathEsfera.getName()+'-into-'+cNodePath.getName(),func1)
        # evento para el fin de colision
        Eventos.accept(self.cNodePathEsfera.getName()+'-out-'+cNodePath.getName(),func2)
    
    # nodo de colision del vehiculo
    def getcNodePath(self):
        return self.cNodePathTubo
    def getcNodeName(self):
        return self.cNodePathTubo.getName()

    def getcNodePathNameFrom(self):
        return self.cNodePathEsfera.getName()

    def setChoque(self,i):
        self.choques.append(i)
    def delChoque(self,i):
        self.choques.remove(i)
    def esta_chocando(self):
        # esta colisionando con otros vehiculos
        if self.choques.__len__() != 0:
            return True
        # NO esta colisionando con otro vehiculos
        else:
            return False
        
    # comprueba si la colision con el vehiculo i ya fue registrada
    def ColisionRegistrada(self,i):
        return self.choques.__contains__(i)    
    
    # nodo de colision del nodoDestino
    def getcNodePathDestino(self):
        return self.cNodePathDestino
    def getcNodeDestinoName(self):
        return self.cNodePathDestino.getName()
    
    # CONTROL DE ESTADO (parar al final de la carretera)
    def EstaParado(self):
        return self.esta_parado
    def Parar(self):
        self.esta_parado = True
    def Reanudar(self):
        self.esta_parado = False    

    # MOVIMIENTO   
    def setVelocidad(self,v):
        self.velocidad = v
    def getVelMax(self):
        return self.velMax    
    def setVelMax(self,v):
        self.velMax = v
    def setAceleracion(self,a):
        self.aceleracion = a
        
    def Acelerar(self,task):
        
        dt = task.time - self.last
    
        if self.velocidad  < 10:
            # acelerar
            self.velocidad = self.velocidad + self.aceleracion * dt
            self.last = task.time
                        
            return Task.cont
        
        else:
            return Task.done
     
    # ORIENTACION
    # calcula la orientacion del vehiculo a partir de 
    # su posicion actual y la posicion de destino
    def CalcularHeading(self):
        
        #vx = float(self.destino[0]) - float(self.coche.getX())
        #vy = float(self.destino[1]) - float(self.coche.getY())
        vxy = self.destino - self.coche.getPos()
        
        if(vxy.getX() == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vxy.getY() == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vxy.getY() / vxy.getX() ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vxy.getX()<0 and vxy.getY()>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vxy.getX()<0 and vxy.getY()<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vxy.getX()>0 and vxy.getY()<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        # almancena el angulo en radianes
        self.headingRad = radians(anguloDegrees)
        self.setHeading(anguloDegrees)
    
    def Orientar(self):
        self.coche.lookAt(self.cNodePathDestino)
        self.coche.setH(self.coche.getH()+180)
    
    def setHeading(self,h):
        # la orientacion inicial es de 270
        # se corrige para que coincida con los 0
        self.coche.setH(h+90)
    def getHeading(self):
        # la orientacion inicial es de 270
        # se corrige para que coincida con los 0
        return self.coche.getH()-90
    
    # POSICION
    def setPos(self,pos):
        self.coche.setFluidPos(pos)
    def getPos(self):
        return self.coche.getPos() 
    def getX(self):
        return self.coche.getX()
    def getY(self):
        return self.coche.getY()
    
    # NODOS ORIGEN, DESTINO Y SIG_DESTINO
    # nodo desde el cual partio el vehiculo
    def setNodoOrigen(self,nodo):
        self.nodo_origen = nodo
    def getNodoOrigen(self):
        return self.nodo_origen
    
    # nodo hacia el que se dirige el vehiculo
    def setNodoDestino(self,nodo):
#        # almacena el antiguo destino como origen
#        self.nodo_origen = self.nodo_destino
        # establece el nuevo nodo de destino
        self.nodo_destino = nodo
    def getNodoDestino(self):
        return self.nodo_destino
    
    # nodo del siguiente salto
    def setNodoSigDestino(self,nodo):
#        self.nodo_origen = self.nodo_destino
#        self.nodo_destino =  self.nodo_sig_destino
        self.nodo_sig_destino = nodo
    def getNodoSigDestino(self):
        return self.nodo_sig_destino
    
    # POSICION DESTINO
    # posicion (x,y) hacia la que se dirige el vehiculo
    def setPosDestino(self,pos):
        
        self.destino = pos
        # calcula la nueva direccion del vehiculo
        #self.CalcularHeading()
        # el vehiculo no ha llegado a su nuevo destino
        self.ha_llegado = False
        
        # prueba del nodo de colision de destino
        self.cNodePathDestino.setPos(pos)
        
    def getPosDestino(self):
        return self.destino
    
    # MOVIMIENTO
    def Avanzar(self,dt):
        
        if not self.esta_parado:
            
            if self.velocidad < self.velMax: 
                self.velocidad = self.velocidad + self.aceleracion * dt
            elif self.velocidad > self.velMax:
                if self.velocidad < 1:
                    self.velocidad = 0
                else:
                    self.velocidad = self.velocidad - self.aceleracion * dt * 3.5
            
#            if self.velMax < Escalas['kmh-pxs']*40:
#            self.velocidad = self.velocidad + self.aceleracion * dt
#            elif self.velMax 
#            
#            # distancia euclidea entre el vvehiculo y su destino
#            """ 
#            x = self.coche.getX()
#            y = self.coche.getY()
#            vx = self.destino[0]- x
#            vy = self.destino[1]- y
#            lejania = hypot(abs(vx),abs(vy))
#            """
#            
#            """
#            vlejania = self.destino - self.coche.getPos()
#            
#            if vlejania.length()>Escalas['m-px']*0.5:
#                
#                # para evitar el fallo de salida
#                self.CalcularHeading()
#    
#                
#                # calculo del desplazamiento pos cada eje
#                #x = x + (cos(self.headingRad) * self.velocidad ) *dt
#                #y = y + (sin(self.headingRad) * self.velocidad ) *dt
#                
#                #
#                # actualiza la posicion del vehiculo    
#                #self.setPos( (x,y) )
#                #self.coche.setX(x)
#                #self.coche.setY(y)
#                #
#            
#                pos = self.coche.getPos()
#                pos.addX( cos(self.headingRad) * self.velocidad  *dt )
#                pos.addY( sin(self.headingRad) * self.velocidad  *dt )
#                self.coche.setPos(pos)
#                #self.ha_llegado = False
#            
#            else:
#                self.ha_llegado = True
#            """ 
             
            pos = self.coche.getPos()
            pos  = self.destino - pos
            pos.normalize()
            pos = pos * (self.velocidad*dt)
            self.coche.setPos(pos+self.coche.getPos())
            
            
    def HaLlegado(self):
        return self.ha_llegado
        
    def dettach(self):
        self.coche.detachNode()
    def hide(self):
        self.coche.hide()
        # lo aleja del escenario
        self.coche.setPos(0,0,-Escalas['m-px']*10)    
    
    def reparentTo(self,parent):
        self.coche.reparentTo(parent)
       
    def __del__(self):
        #print 'eliminando vehiculo __del__',self.getcNodeName()
        self.coche.removeNode()
        self.cNodePathEsfera.removeNode()
        self.cNodePathTubo.removeNode()
        self.cNodePathDestino.removeNode()
        self.cNodePathCoche.removeNode()
    

class Circulacion():
    
    def __init__(self,nodo,nodo2d):
        
        self.NodoEscenario = nodo
        self.NodoEscenario2d = nodo2d
        
        # nodo de referencia para el arbol de renderizado
        self.NodoCirculacion = NodePath('circulacion')
        self.NodoCirculacion2d = NodePath('circulacion2d')
        
        # EVENTOS
        self.EventosCirculacion = DirectObject()
        
        # FUENTES
        fontSansBold = loader.loadFont('fuentes/FreeSansBold.ttf')
        fontSerif = loader.loadFont('fuentes/FreeSerif.ttf')
        
        # COLISIONES
        # inicializa las colisiones en el loop principal
        base.cTrav = CollisionTraverser()
        #base.cTrav.showCollisions(render)
        # define el manejador de eventos a utilizar
        self.collHandEvent=CollisionHandlerEvent()
        # patrones del manejador de eventos
#        self.collHandEvent.addInPattern('%fn-into')
        self.collHandEvent.addInPattern('%fn-into-%in')
        self.collHandEvent.addOutPattern('%fn-out-%in')
                
        # INSTRUCCIONES
        
        # texto de velocidad
        self.texto_velocidad = OnscreenText(text='',
                                       pos=(-1.3,0.77),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
        # texto de direccion/destino actual del jugador
        self.direccion_actual = OnscreenText(text='',
                                       pos=(-1.3,0.69),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
#        # texto de direccion/destino proximo del jugador
#        self.direccion_siguiente = OnscreenText(text='',
#                                       pos=(-1.3,0.6105),
#                                       fg=(1,1,1,1),
#                                       bg=(0,0,0,0.4),
#                                       scale = 0.05,
#                                       align = TextNode.ALeft,
#                                       font = fontSansBold,
#                                       parent=self.NodoCirculacion2d,
#                                       mayChange=True)
#        
#        # texto de direccion/destino proximo del jugador
#        self.direccion_siguiente_salto = OnscreenText(text='',
#                                       pos=(-1.3,0.53),
#                                       fg=(1,1,1,1),
#                                       bg=(0,0,0,0.4),
#                                       scale = 0.05,
#                                       align = TextNode.ALeft,
#                                       font = fontSansBold,
#                                       parent=self.NodoCirculacion2d,
#                                       mayChange=True)
        
        # texto para indicar que ha llegado al limite del mapa
        self.limiteMapa = OnscreenText(text='Ha llegado al limite de mapa, pulse \'control-q\' para volver al menú.',
                                       pos=(0,0,0),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.08,
                                       align = TextNode.ACenter,
                                       font = fontSerif,
                                       parent=None)
        self.limiteMapa.detachNode()
        
        # FLECHA DE DIRECCION SOBRE EL SUELO
        self.flecha = Flecha(self.NodoCirculacion,self.NodoCirculacion2d)
        
        # CIRCULACION
        # total de vehculos en el escenario
        self.nvehiculos = 25
        
        # vehiculos indexados por numero de cNode
        self.vehiculos = {}
        # vehiculos en espera de ser rehubicados
        self.vehiculos_fuera = []
        
        # MAPA DE VELOCIDADES
        # correspondencia entre la velocidad y la siguiente
        self.velocidades_aumentar = {0:20*Escalas['kmh-pxs'],
                                     20*Escalas['kmh-pxs']:50*Escalas['kmh-pxs'],
                                     50*Escalas['kmh-pxs']:80*Escalas['kmh-pxs'],
                                     80*Escalas['kmh-pxs']:120*Escalas['kmh-pxs'],
                                     120*Escalas['kmh-pxs']:120*Escalas['kmh-pxs']}
        # correspondencia entre la velocidad y la anterior
        self.velocidades_disminuir = {120*Escalas['kmh-pxs']:80*Escalas['kmh-pxs'],
                                      80*Escalas['kmh-pxs']:50*Escalas['kmh-pxs'],
                                      50*Escalas['kmh-pxs']:20*Escalas['kmh-pxs'],
                                      20*Escalas['kmh-pxs']:20*Escalas['kmh-pxs'],
                                      20*Escalas['kmh-pxs']:0,
                                      0:0 }  
        
        # giro aplicado a la camara
        self.giroCamara = 0
         
    def Crear(self,map,nodo_origen=None,nodo_destino=None):
        
        # mapa del escenario
        self.mapa = map
        
        # VEHICULO DEL JUGADOR
        
        if nodo_origen is None:
            
            # indice del buscador del nodo adecuado
            i = 0
            
            lista_nodos = self.mapa.getListaNodosMatrizCamino()
            # mientras no exista nodos disponibles en el tercer destino
            nodo_sig_destino = []
            esta_fuera = False
            while nodo_sig_destino.__len__() == 0 or esta_fuera:
                nodo_origen = lista_nodos[i]
                pos = self.mapa.getNodoPosById( nodo_origen )
                if pos.getX() < self.mapa.getBounds().getMinX():
                    esta_fuera = True
                elif pos.getX() > self.mapa.getBounds().getMaxX():
                    esta_fuera = True 
                elif pos.getY() < self.mapa.getBounds().getMinY():
                    esta_fuera = True
                elif pos.getY() > self.mapa.getBounds().getMaxY():
                    esta_fuera = True
                else:
                    esta_fuera = False
                
                # determina el nodo de destino inmediato
                nodo_destino = self.CalcularNodoDestino(nodo_origen,nodo_origen)
                # calcula el nodo del siguiente salto
#                # el tercer parametro es apra obtener la lista de nodos disponibles
#                nodo_sig_destino = self.CalcularNodoDestino(nodo_origen,nodo_destino,'lista')
                
                i= i+1    
            
            # para el comienzo automatico calcula la porcion de mapa de inicio, en el comienzo manual se
            # hace desde la clase escenario
            self.mapa.CalcularPorcionMapa(self.mapa.getNodoPosById( nodo_origen ), base.camLens.getFar()*2)
            
            # fin while
        
        else: # nodo_origen != None:
#            for n in nodo_inicio:
#                pos = self.mapa.getNodoPosById( n )
#                if pos.getX() > self.mapa.getBounds().getMinX() and pos.getX() < self.mapa.getBounds().getMaxX():
#                    if pos.getY() > self.mapa.getBounds().getMinY() and pos.getY() > self.mapa.getBounds().getMaxY():
#                        nodo_origen = n
#                    else:
#                        nodo_origen = n
#                else:
#                    nodo_origen = n
            
            # determina el nodo de destino inmediato
            if nodo_destino is None:
                nodo_destino = self.CalcularNodoDestino(nodo_origen,nodo_origen)
            # calcula el nodo del siguiente salto
#            # el tercer parametro es apra obtener la lista de nodos disponibles
#            nodo_sig_destino = self.CalcularNodoDestino(nodo_origen,nodo_destino,'lista')
        
        
        # FLECHA    
        self.flecha.ProximoCruce(nodo_origen,nodo_destino)
        taskMgr.add(self.flecha.OrientarLetrero,'task_cruce')
        
        nodo_sig_destino = self.CalcularNodoDestino(nodo_origen,nodo_destino,'lista')
        if nodo_sig_destino.__len__()>1:
            nodo_sig_destino = [self.flecha.getNodoDestino()]
            
        # la posicion de destino sera el cruce de carriles
        pos1 = nodo_origen.getPos()
        pos2 = nodo_destino.getPos()
        pos3 = nodo_sig_destino[0].getPos()
        
        # si en ese nodo solo hay camino unico la carretera esta en el centro
        if nodo_origen.getOneWay() == 'yes':
            pos = pos1
        else:
            # establece como posicion de destino el cruce de carriles
            pos = self.CalcularPosicionesCarriles(pos1, pos2)[0]
        
        # crea el vehiculo del jugador
        self.jugador = Vehiculo(self.NodoCirculacion,
                                nodo_origen,
                                pos,
                                1,
                                0)
        
        # registra el vehiculo en el diccionario
        self.vehiculos[0] = self.jugador
        
        # COLISIONES
        # incluye al vehiculos en el entorno de colision
        self.jugador.addColliderHand(self.collHandEvent)
        # registra el evento de llegada a destino del vehiculo        
        self.jugador.setCollDestino(self.EventosCirculacion,self.setRumboJugador)
        
              
        # en este orden por funcionamiento interno
        # establce el tercer salto
#        self.jugador.setNodoSigDestino(nodo_sig_destino[0])
        

        if nodo_sig_destino.__len__()>1:
            self.jugador.setNodoSigDestino(self.flecha.getNodoDestino())
        else:
            self.jugador.setNodoSigDestino(nodo_sig_destino[0])
            
        # establce el destino inmediato
        self.jugador.setNodoDestino(nodo_destino)
        
        pos_destino = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(), 
                                                         self.jugador.getNodoSigDestino())
        
        self.jugador.setPosDestino(pos_destino)

        self.jugador.Orientar()
        
        # establece la lista de posibles destinos
        self.jugador.lista_sg = nodo_sig_destino
        self.jugador.num__nsd = 0
        
        # VELOCIDAD
        self.jugador.setVelMax(Escalas['kmh-pxs']*0)
        
        # INSTRUCCIONES DE DIRECCION
        self.direccion_actual.node().setText('Posición: '+ self.jugador.getNodoOrigen().getWayName() )
#        self.direccion_siguiente.node().setText('Destino inmediato: '+ self.jugador.getNodoDestino().getWayName() )        
#        self.direccion_siguiente_salto.node().setText('Siguiente destino: '+ self.jugador.getNodoSigDestino().getWayName() )
        
        # POSICION INICIAL DE LA CAMARA
        pos = nodo_origen.getPos()
        base.camera.setPos(pos[0],pos[1],Escalas['m-px']*6)
        self.ActualizarCamara()
        
        # calcula las posiciones de partida de la circulacion
        origen = self.jugador.getNodoOrigen()
        distancia = base.camLens.getFar()*2
#        circulacion_pos_ini = self.CalcularPosInicioCirculacion(origen,distancia)
        circulacion_pos_ini = self.mapa.getPorcionCamino()
        
        if circulacion_pos_ini.__contains__(self.jugador.getNodoOrigen()):
            circulacion_pos_ini.remove(self.jugador.getNodoOrigen())
        if circulacion_pos_ini.__contains__(self.jugador.getNodoDestino()):
            circulacion_pos_ini.remove(self.jugador.getNodoDestino())
        
        #CREACION DE LOS VEHICULOS QUE FORMAN LA CIRCULACION
        # crea los vehiculos de circulacion ordenaria
        i = 1 # contador para nombrar el nodo de colision de cada vehiculo
        for nodo in circulacion_pos_ini:
            
            # controla el numero de vehiculos
            if i<self.nvehiculos:
                
                pos_inicial = nodo.getPos()
                v = Vehiculo(self.NodoCirculacion,nodo,pos_inicial,0,str(i))
                
                # determina el nodo de destino inmediato
                nodo_destino = self.CalcularNodoDestino(nodo,nodo)
                # calcula el nodo del siguiente salto
                nodo_sig_destino = self.CalcularNodoDestino(nodo,nodo_destino)
                
                # EN ESTE ORDEN POR FUNCIONAMIENTO DE LOS METODOS
                # establece destino del siguiente salto
                v.setNodoSigDestino( nodo_sig_destino )
                # establece el nodde de destino inmediato
                v.setNodoDestino( nodo_destino )
                
                # COLISIONES
                # incluye al vehiculos en el entorno de colision
                v.addColliderHand(self.collHandEvent)
                # registra el evento de llegada a destino del vehiculo        
                v.setCollDestino(self.EventosCirculacion,self.setRumboVehiculo)

                # si existe un nodo de destino siguiente
                if v.getNodoDestino() != v.getNodoSigDestino():
                    
                    # la posicion de destino sera el cruce de carriles
                    pos1 = v.getNodoOrigen().getPos()
                    pos2 = v.getNodoDestino().getPos()
                    pos3 = v.getNodoSigDestino().getPos()
                    
                    
                    # si en ese nodo solo hay camino unico la carretera esta en el centro
                    if v.getNodoDestino().getOneWay() == 'yes':
                        pos_origen = pos1
                    else:
                        pos_origen = self.CalcularPosicionesCarriles(pos1, pos2)[0] 
                        
                    pos_destino = self.CalcularCruceCarrilesNodos(v.getNodoOrigen(),
                                                         v.getNodoDestino(), 
                                                         v.getNodoSigDestino())
                    
                    v.setPos(pos_origen)
                    v.setPosDestino(pos_destino)
                    v.Orientar()                              
                    
                    # VELOCIDAD
                    v.setVelMax(self.getVelTramo(v.getNodoOrigen(),v.getNodoDestino())*Escalas['kmh-pxs'])
                    
                    self.vehiculos[i] = v
                    i = i + 1
                    
                # existe un destino inmediato    
                elif v.getNodoOrigen() != v.getNodoDestino():
                    
                    # calcula la posicion de destino como al final del carril
                    pos1 = v.getNodoOrigen().getPos()
                    pos2 = v.getNodoDestino().getPos()
                    # pos es una tupla con el inicio y final del carril
                    
                    # si en ese nodo solo hay camino unico la carretera esta en el centro
                    if v.getNodoDestino().getOneWay() == 'yes':
                        pos_origen = pos1
                        pos_destino = pos2
                        
                    else:
                        pos_origen = self.CalcularPosicionesCarriles(pos1, pos2)[0] 
                        # establece como posicion de destino el cruce de carriles
                        pos_destino = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                        
                    
                    v.setPos(pos_origen)
                    # la posicion de destino es el final del carril
                    v.setPosDestino(pos_destino)
                    v.Orientar()
                
                    # VELOCIDAD
                    v.setVelMax(self.getVelTramo(v.getNodoOrigen(),v.getNodoDestino())*Escalas['kmh-pxs'])
                    
                    self.vehiculos[i] = v
                    i = i + 1
                    
                # el vehiculo no tiene destino donde ir
                else:
                    self.vehiculos_fuera.append(i)
                    v.setPos(VBase3(0,0,-100))
                    v.Parar()
   
        
        print 'Total de vehiculos en circulacion: ', self.vehiculos.__len__()
        
        # INSTRUCCIONES
        
        self.texto_velocidad.setText('Velocidad máxima: ' + str(self.jugador.velMax/Escalas['kmh-pxs']).split('.')[0])
        
        # TASK
        self.gametask = taskMgr.add(self.Movimiento,'movimiento')
        self.gametask.last = 0
        
        # COLISIONES ENTRE VEHICULOS
        for v in self.vehiculos:
            for w in self.vehiculos:
                if v != w:
                    self.vehiculos[v].setCollVehiculo(self.EventosCirculacion,
                                                      self.Choque,
                                                      self.FindeChoque,
                                                      self.vehiculos[w].getcNodePath())
        
        
        # EVENTOS
        self.ActivarTeclado()
        
        # ESCENA
        self.NodoCirculacion.reparentTo(self.NodoEscenario)
        self.NodoCirculacion2d.reparentTo(self.NodoEscenario2d)

    def Eliminar(self):
        
        print 'Circulacion:Eliminar'
        
        # TASK
        taskMgr.remove('movimiento')
        taskMgr.remove('task_cruce')
        
        # EVENTOS
        self.EventosCirculacion.ignoreAll()
        
        # ELIMINAR VEHICULOS
        
        for v in self.vehiculos.keys():
            self.vehiculos[v].__del__()
            self.vehiculos.pop(v)
            
        # DETACH
        
        # notificacion de final del mapa
        self.limiteMapa.detachNode()
        
        self.NodoCirculacion.detachNode()    
        self.NodoCirculacion2d.detachNode()
        
        # REMOVE
#        self.cNodePathBounds.removeNode()
    
    
    # desactiva los eventos de teclado de la circulacion
    def DesactivarTeclado(self):
        
        self.EventosCirculacion.ignore('arrow_up')
        self.EventosCirculacion.ignore('arrow_down')
        self.EventosCirculacion.ignore('r')
        self.EventosCirculacion.ignore('arrow_left')
        self.EventosCirculacion.ignore('arrow_right')
    
        self.EventosCirculacion.ignore('a')
        self.EventosCirculacion.ignore('a_up')
        self.EventosCirculacion.ignore('d')
        self.EventosCirculacion.ignore('d_up')
        self.EventosCirculacion.ignore('s')
    
    def ActivarTeclado(self):
        
        self.EventosCirculacion.accept("arrow_left",self.CambiarDestino,['arrow_left'])
        self.EventosCirculacion.accept("arrow_right",self.CambiarDestino,['arrow_right'])
        self.EventosCirculacion.accept("arrow_up",self.AumentarVelocidad)
        self.EventosCirculacion.accept("arrow_down",self.DisminuirVelocidad)
        self.EventosCirculacion.accept("r",self.ActivarInvertirRumbo)
    
        self.EventosCirculacion.accept('a',self.ActivarGirarCamara,[1])
        self.EventosCirculacion.accept('a-up',self.DetenerGirarCamara)
        self.EventosCirculacion.accept('d',self.ActivarGirarCamara,[-1])
        self.EventosCirculacion.accept('d-up',self.DetenerGirarCamara)
        self.EventosCirculacion.accept('s',self.CentrarCamara)
    
    """
    detiene la circulacion
    """
    def Parar(self):
    
        self.jugador.Parar()
    
#        taskMgr.remove('movimiento')
    
        # cancela todos los eventos
        self.EventosCirculacion.ignore('arrow_left')
        self.EventosCirculacion.ignore('arrow_right')
        self.EventosCirculacion.ignore('arrow_up')
        self.EventosCirculacion.ignore('arrow_down')
    
    
    #reanuda la circulacion
    def Reanudar(self):
        
        self.jugador.Reanudar()
        
        # TASK
#        self.gametask = taskMgr.add(self.Movimiento,'movimiento')
#        self.gametask.last = 0
        
        # reactiva los eventos de la circulacion
        self.EventosCirculacion.accept("d",self.CambiarDestino)
        self.EventosCirculacion.accept("arrow_up",self.AumentarVelocidad)
        self.EventosCirculacion.accept("arrow_down",self.DisminuirVelocidad)
    
    def NotificarLimiteMapa(self,entry):

        self.limiteMapa.reparentTo(self.NodoCirculacion2d)
        self.jugador.Parar()
#        messenger.send('morro_0-into-bounds',[None])
        
    def CambiarDestino(self,key):
        
        print 'Circulacion:CambiarDestino'
        
        if key == 'arrow_right':
            self.flecha.DestinoAnterior(self.mapa)
        else: #key == 'arrow_left'
            self.flecha.DestinoSiguiente(self.mapa)
        
        # si el jugador esta junto al cruce
        if self.jugador.getNodoDestino() == self.flecha.getNodo():
            
            self.jugador.setNodoSigDestino(self.flecha.getNodoDestino())
            
            # la posicion de destino sera el cruce de carriles
            pos1 = self.jugador.getNodoOrigen().getPos()
            pos2 = self.jugador.getNodoDestino().getPos()
            pos3 = self.jugador.getNodoSigDestino().getPos()
            
            
            # establece como posicion de destino el cruce de carriles
            pos = cruce = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                             self.jugador.getNodoDestino(), 
                                                             self.jugador.getNodoSigDestino())
            self.jugador.setPosDestino(pos)
            self.jugador.CalcularHeading() 
    
    def Choque(self,entry):

        # comprueba que ha colisionado con otro vehiculo
        i = int( entry.getFromNodePath().getName().split('_')[-1] )
        
        # las colision se profucen en los dos sentidos, a->b y b->a
        # pero solo se registra una de las dos
        j = int( entry.getIntoNodePath().getName().split('_')[-1])
        if not self.vehiculos[j].ColisionRegistrada(int(i)):
        
            # detiene el vehiculo
            self.vehiculos[i].setVelocidad(0)
            # detien la aceleracion
            self.vehiculos[i].setAceleracion(0)
            
            # registra el vehiculo colisionado
            self.vehiculos[i].setChoque( j )
        
    def FindeChoque(self,entry):
        
        # comprueba que ha colisionado con otro vehiculo
        #if True or not re.match("(_[0-9]*)$",entry.getIntoNodePath().getName()):
            
        # obtiene el identificador del vehiculo que colisiona
        i = int( entry.getFromNodePath().getName().split('_')[-1] )
        # el vehiculo colisionado ua no lo es
        
        # las colision se profucen en los dos sentidos, a->b y b->a
        # pero solo se ha registrado una de las dos
        # solo se elimina una de las dos
        j = int( entry.getIntoNodePath().getName().split('_')[-1] )
        if self.vehiculos[i].ColisionRegistrada(j):
            self.vehiculos[i].delChoque( j )
        
        # si el vehiculo ya no colisiona con ningun vehiculo reanuda la marcha
        if not self.vehiculos[i].esta_chocando():
            self.vehiculos[i].setAceleracion(Escalas['m-px']*4.8)
    
#    # recibe el nodo origen del vehiculo de referencia
#    def CalcularPosInicioCirculacion(self,jugador,distanciaMax,distanciaMin=0):
#        
#        return self.CalcularPosInicioCirculacion3()
#
#        circulacion_pos_ini = []
#         
#        # obtiene los nodos hijo de la posicion de inicio del jugador
#        siguientes = self.mapa.getListaNodosSiguientes(jugador)
#        anteriores = self.mapa.getListaNodosAnteriores(jugador)
#        
#        # rango de elementos añadidos
#        primero = 0
#        ultimo = -1
#        
#        for i in siguientes:
#            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
#                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                if dif < distanciaMax:
#                    circulacion_pos_ini.append(i)
#                    
#        for i in anteriores:
#            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
#                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                if dif < distanciaMax:
#                    circulacion_pos_ini.append(i)
#                    
#        ultimo = circulacion_pos_ini.__len__()-1
#        
#        while primero <= ultimo:
#             
#            # recorre los nodods añadidos en la ultima iteracion
#            while primero <= ultimo:
#                 
#                siguientes = self.mapa.getListaNodosSiguientes( circulacion_pos_ini[primero] )
#                anteriores = self.mapa.getListaNodosAnteriores( circulacion_pos_ini[primero] )
#                 
#                for i in siguientes:
#                    if not circulacion_pos_ini.__contains__(i) and i!=jugador:
#                        # no es un nodo demasiado lejano
#                        dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                        if dif < distanciaMax:
#                            circulacion_pos_ini.append(i)
#                            
#                for i in anteriores:
#                    if not circulacion_pos_ini.__contains__(i) and i!=jugador:
#                        dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                        if dif < distanciaMax:
#                            circulacion_pos_ini.append(i)
#                
#                primero = primero+1
#                 
#            ultimo = circulacion_pos_ini.__len__()-1
#    
#        # existe distancia minima
#        if distanciaMin !=0 :
#            for i in circulacion_pos_ini:
#                # si no esta a la distancia minima elimina el nodo
#                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                if dif < distanciaMin:
#                    circulacion_pos_ini.remove(i)
#    
#        return circulacion_pos_ini
#    
#    # recibe el nodo origen del vehiculo de referencia
#    def CalcularPosInicioCirculacion2(self,jugador,distanciaMax,distanciaMin=0):
#        
#        circulacion_pos_ini = []
#        
#        for i in self.mapa.getMatrizCamino().getListaNodos2():     
#        
#            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
#                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
#                if dif < distanciaMax and dif > distanciaMin:
#                    circulacion_pos_ini.append(i)
#        
#        return circulacion_pos_ini
#    
#    def CalcularPosInicioCirculacion3(self):
#        
##        lista = []
##        for i in self.mapa.getPorcionCamino(): 
##            if i != self.jugador.getNodoOrigen():
##                if i != self.jugador.getNodoDestino():
##                    lista.append(i)
##                    
##        return lista
#
#        return self.mapa.getPorcionCamino()
    
    def RehubicarVehiculo(self,v,rescatar=False):
        
#        print 'Circulación:RehubicarVehiculo'
        
        origen = self.jugador.getNodoOrigen()
        
        distanciaMax = base.camLens.getFar()*2
        distanciaMin = base.camLens.getFar()
#        circulacion_pos_ini = self.CalcularPosInicioCirculacion(origen,distanciaMax,distanciaMin)
        circulacion_pos_ini = self.mapa.getPorcionCamino()
        
        len = circulacion_pos_ini.__len__()
        if len >10:
                
            nodo = circulacion_pos_ini[ randint(0,len-1) ]
            while nodo == self.jugador.getNodoOrigen() or nodo == self.jugador.getNodoDestino(): 
                nodo = circulacion_pos_ini[ randint(0,len-1) ]
                
            # determina el nodo de destino inmediato
            nodo_destino = self.CalcularNodoDestino(nodo,nodo)
            # calcula el nodo del siguiente salto
            nodo_sig_destino = self.CalcularNodoDestino(nodo,nodo_destino)
            
            # EN ESTE ORDEN POR FUNCIONAMIENTO DE LOS METODOS
            # establece destino del siguiente salto
            self.vehiculos[v].setNodoSigDestino( nodo_sig_destino )
            # establece el nodde de destino inmediato
            self.vehiculos[v].setNodoDestino( nodo_destino )
            # nuevo nodo de origen
            self.vehiculos[v].setNodoOrigen(nodo)
            
            # si existe un nodo de destino siguiente
            if self.vehiculos[v].getNodoDestino() != self.vehiculos[v].getNodoSigDestino():
                
                # la posicion de destino sera el cruce de carriles
                pos1 = self.vehiculos[v].getNodoOrigen().getPos()
                pos2 = self.vehiculos[v].getNodoDestino().getPos()
                pos3 = self.vehiculos[v].getNodoSigDestino().getPos()
                
                
                # calcula la posicion de partida del vehiculo
                if self.vehiculos[v].getNodoOrigen().getOneWay() == 'yes':
                    self.vehiculos[v].setPos(pos1)
                else:
                    pos = self.CalcularPosicionesCarriles(pos1, pos2)
                    self.vehiculos[v].setPos(pos[0])
                
                cruce = self.CalcularCruceCarrilesNodos(self.vehiculos[v].getNodoOrigen(),
                                                         self.vehiculos[v].getNodoDestino(), 
                                                         self.vehiculos[v].getNodoSigDestino())
                self.vehiculos[v].setPosDestino(cruce)
                
                self.vehiculos[v].Orientar()
                
                # VELOCIDAD
                self.vehiculos[v].setVelMax(self.getVelTramo(self.vehiculos[v].getNodoOrigen(),
                                                             self.vehiculos[v].getNodoDestino()) * \
                                            Escalas['kmh-pxs'])                              
                
                self.vehiculos[v].Reanudar()
                
            # existe un destino inmediato    
            elif self.vehiculos[v].getNodoOrigen() != self.vehiculos[v].getNodoDestino():
                
                # calcula la posicion de destino como al final del carril
                pos1 = self.vehiculos[v].getNodoOrigen().getPos()
                pos2 = self.vehiculos[v].getNodoDestino().getPos()
                # pos es una tupla con el inicio y final del carril
                
                pos = self.CalcularPosicionesCarriles(pos1, pos2)
                
                if self.vehiculos[v].getNodoOrigen().getOneWay() == 'yes':
                    self.vehiculos[v].setPos(pos1)
                else:
                    self.vehiculos[v].setPos(pos[0])
                
                if self.vehiculos[v].getNodoDestino().getOneWay() == 'yes':
                    self.vehiculos[v].setPosDestino(pos2)
                else:
                    # la posicion de destino es el final del carril
                    self.vehiculos[v].setPosDestino(pos[1])
                    
                self.vehiculos[v].Orientar()
            
                # VELOCIDAD
                self.vehiculos[v].setVelMax(self.getVelTramo(self.vehiculos[v].getNodoOrigen(),
                                                             self.vehiculos[v].getNodoDestino()) * \
                                            Escalas['kmh-pxs'])
                
                self.vehiculos[v].Reanudar()
            
        else:
            self.vehiculos_fuera.append(v)
            self.vehiculos[v].setPos(VBase3(0,0,-100))
            self.vehiculos[v].Parar()

        if rescatar == True and self.vehiculos_fuera.__len__()>0:
            self.RehubicarVehiculo( self.vehiculos_fuera[0],True)
    
    def CalcularNodoDestino(self,nodo_origen,nodo_destino,lista=False):
            
        listaAdyacentes = []
        
#        for nd in self.mapa.getListaAdyacentes(nodo_destino):
#            if nd != nodo_origen:
#                listaAdyacentes.append(nd)

        for nd in nodo_destino.getListaAdyacentes():
            if nd != nodo_origen:
                listaAdyacentes.append(nd)
        
        if listaAdyacentes.__len__()>0:
            if lista:
                return listaAdyacentes
            else:
                shuffle(listaAdyacentes)
                return listaAdyacentes[0]
        else:
            if lista:
                return [nodo_destino]
            else:
                return nodo_destino
        
    
    # recibe las posiciones de los tres nodos que componen
    # los dos tramos de caretera, halla la interseccion de las
    # dos rectas de los dos carriles
    def CalcularCruceCarriles(self,pos1,pos2,pos3):

        #la rectas que marcan los carriles no pasan
        # por le centro de la carretera, hay que calcular
        # el desplazamiento, pos2 y pos3 estan asociados
        # al mimso nodo pero a rectas diferentes
        
        # puntos de referencia para la primera recta        
        tramo1 = self.CalcularPosicionesCarriles(pos1, pos2)
        
        # puntos de referencia para la segunda recta
        tramo2 = self.CalcularPosicionesCarriles(pos2, pos3)
        
        # tupla posicion de inicio del carril
        pos1 = tramo1[0]
        # tupla posicion de final del carril
        pos2 = tramo1[1]
                
        pos3 = tramo2[0] 
        pos4 = tramo2[1]
        
            
        # si los dos primero puntos estan en la misma x
        # calcula para que y pasa por x la segunda recta
        if abs(pos1[0]-pos2[0])<0.001 and abs(pos3[0]-pos4[0])<0.001:
            # al final de su carril
            x = pos2[0]
            y = pos2[1]
            
        elif abs(pos1[0]-pos2[0])<0.001:
            x = pos1[0]
            
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            b2 = pos3[1] - m2*pos3[0]
            y = m2*x + b2
            
        # si el segundo y tercer punto esta en la misma x
        # calcual para que y para por x la primera recta
        elif abs(pos3[0]-pos4[0])<0.001:
            x = pos3[0]
            
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            b1 = pos1[1] - m1*pos1[0]
            y = m1*x + b1
            
            
        # en otro caso calcula ambas recta y su punto de corte
        else:
            # m = (y1 - y2)/(x1 - x2)
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            
            if abs(m1-m2)<0.001:
                # las rectar tiene la misma direccion
                # coinciden al final e inicio de carril
                # los dos tramos estan en linea
                x = pos2[0]
                y = pos2[1]
            
            else:
                # b = y - mx
                b1 = pos1[1] - m1*pos1[0]
                b2 = pos3[1] - m2*pos3[0]
                
                x = (b2-b1)/(m1-m2)
            
                y = m1*x + b1
     
        return VBase3(x,y,0)

    def CalcularCruceCarrilesNodos(self,nodo1,nodo2,nodo3):
        
        if nodo2.getOneWay() == 'yes':
            return nodo2.getPos()

        posn1 = nodo1.getPos()
        posn2 = nodo2.getPos()
        posn3 = nodo3.getPos()
        
        #la rectas que marcan los carriles no pasan
        # por le centro de la carretera, hay que calcular
        # el desplazamiento, pos2 y pos3 estan asociados
        # al mimso nodo pero a rectas diferentes
        
#        if oneway1 == 'yes' and oneway2 == 'yes': 
#            tramo1 = self.CalcularPosicionesCarriles(posn1, posn2)
#        # se circula por el carril central
#        else:
#            tramo1 = (posn1,posn2)
#        
#        if oneway2 == 'yes' and oneway3 == 'yes': 
#            # puntos de referencia para la primera recta        
#            tramo2 = self.CalcularPosicionesCarriles(posn2, posn3)
#        # se circula por el carril central
#        else:
#            tramo2 = (posn2,posn3)
#            
        
        tramo1 = self.CalcularPosicionesCarriles(posn1, posn2)
        tramo2 = self.CalcularPosicionesCarriles(posn2, posn3)
        
        
        # tupla posicion de inicio del carril
        pos1 = tramo1[0]
        # tupla posicion de final del carril
        pos2 = tramo1[1]
                
        pos3 = tramo2[0] 
        pos4 = tramo2[1]
        
            
        # si los dos primero puntos estan en la misma x
        # calcula para que y pasa por x la segunda recta
        if abs(pos1[0]-pos2[0])<0.001 and abs(pos3[0]-pos4[0])<0.001:
            # al final de su carril
            x = pos2[0]
            y = pos2[1]
            
        elif abs(pos1[0]-pos2[0])<0.001:
            x = pos1[0]
            
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            b2 = pos3[1] - m2*pos3[0]
            y = m2*x + b2
            
        # si el segundo y tercer punto esta en la misma x
        # calcual para que y para por x la primera recta
        elif abs(pos3[0]-pos4[0])<0.001:
            x = pos3[0]
            
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            b1 = pos1[1] - m1*pos1[0]
            y = m1*x + b1
            
            
        # en otro caso calcula ambas recta y su punto de corte
        else:
            # m = (y1 - y2)/(x1 - x2)
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            
            if abs(m1-m2)<0.001:
                # las rectar tiene la misma direccion
                # coinciden al final e inicio de carril
                # los dos tramos estan en linea
                x = pos2[0]
                y = pos2[1]
            
            else:
                # b = y - mx
                b1 = pos1[1] - m1*pos1[0]
                b2 = pos3[1] - m2*pos3[0]
                
                x = (b2-b1)/(m1-m2)
            
                y = m1*x + b1
     
        return VBase3(x,y,0)

    
    # calcula la posicion de partida de cada carril
    # formado para cada par de nodos
    def CalcularPosicionesCarriles(self,pos1,pos2):
        
        # angulo desde pos1 a pos 2
        """
        vx = pos2[0] - pos1[0]
        vy = pos2[1] - pos1[1]
        """
        vxy = pos2 - pos1
        
        if(vxy.getX() == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vxy.getY() == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vxy.getY() / vxy.getX() ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vxy.getX()<=0 and vxy.getY()>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vxy.getX()<=0 and vxy.getY()<=0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vxy.getX()>0 and vxy.getY()<=0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        # desplazamiento desde pos1
        alpha = anguloDegrees - 90
        betaRadians = radians(alpha)
        
        desplaz_carril = Escalas['m-px']*1.5
        
        pos1 =  ( VBase3(pos1[0]+cos(betaRadians)*desplaz_carril , pos1[1]+sin(betaRadians)*desplaz_carril,0) )
        """
        pos1.addX(cos(betaRadians)*3.2)
        pos1.addY(sin(betaRadians)*3.2)
        """
        
        #desplazamiento desde pos2
        #alpha = anguloDegrees + 90
        #omegaRadians = radians(alpha)
        #pos2 =  ( (pos2[0]+cos(omegaRadians)*3.2 , pos2[1]+sin(omegaRadians)*3.2) )
        
        pos2 =  ( VBase3(pos2[0]+cos(betaRadians)*desplaz_carril , pos2[1]+sin(betaRadians)*desplaz_carril,0) )
        """
        pos2.addX(cos(betaRadians)*3.2)
        pos2.addY(sin(betaRadians)*3.2)
        """
        return (pos1,pos2)
    
    def Movimiento(self,task):
    
        
        # calcula el tiempo entre dos ejecuciones de esta funcion
        
        dt = task.time - task.last
        task.last = task.time
        
        for i in self.vehiculos:
            
            pos_jugador = self.vehiculos[0].getPos()
            pos_vehiculo = self.vehiculos[i].getPos()
            distancia = (pos_vehiculo - pos_jugador).length()
            if distancia <= base.camLens.getFar()*2:
                self.vehiculos[i].Avanzar(dt)
                #self.vehiculos[i].Orientar(None)
            # rehubicacion de la circulacion
            else:
                self.RehubicarVehiculo(i)
                
            
        self.ActualizarCamara()
        
#        # VELOCIDAD
#        self.texto_velocidad.setText('Velocidad: ' + str( str(self.jugador.velocidad/Escalas['kmh-pxs']).partition('.')[0] ) )
        
        
#        SUSTITUIDO POR EL EVENTO SET RUMBO CALCULAR EL PROXIMO DESTINO
#        
#        
#        
#        if self.jugador.HaLlegado() and (not self.jugador.EstaParado()):
#            
#            nodo_sig_destino = self.CalcularNodoDestino( self.jugador.getNodoDestino(),
#                                                         self.jugador.getNodoSigDestino(),
#                                                         True )
#            
#            self.jugador.lista_sg = nodo_sig_destino
#            # actualiza el numero de destinos disponibles
#            self.jugador.num__nsd = 0
#            
#            total = str(self.jugador.lista_sg.__len__())
#            n = str(self.jugador.num__nsd+1)
#            self.texto_destinos.node().setText('Pulse \'d\' para cambiar el destino. Total: ' + total + ', actual: ' + n) 
#            
#            # establece destino del siguiente salto
#            # actualiza el nodo_origen y nodo_sig_destino
#            self.jugador.setNodoSigDestino( nodo_sig_destino[0] )
#            
#            # existe un destino inmediato
#            if self.jugador.getNodoOrigen() != self.jugador.getNodoDestino():
#            
#                # hay un tercer destino, cruce de carriles
#                if self.jugador.getNodoDestino() != self.jugador.getNodoSigDestino():
#                                        
#                # origen destino y sig_destino son diferentes
#                    
#                    # la posicion de destino sera el cruce de carriles
#                    pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
#                    pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
#                    pos3 = self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() )
#                    
#                    # establece como posicion de destino el cruce de carriles
#                    cruce = self.CalcularCruceCarriles(pos1, pos2, pos3)
#                    self.jugador.setPosDestino(cruce)
#                    """ sustituida por  el evento Orientar
#                    self.jugador.CalcularHeading()
#                    """
#                    # FLECHA
#                    """
#                    direccion = self.CalcularPosicionesCarriles(pos2,pos3)
#                    self.flecha.CalcularHeading(cruce,direccion[1])
#                    self.flecha.setPos(cruce)
#                    """
#                    self.flecha.setPos(cruce)
#                    self.flecha.setDestino( self.CalcularPosicionesCarriles(pos2,pos3)[1] )
#                    self.flecha.Orientar()
#                    
#                    # FLECHA MINI
#                    self.flecha_mini.CalcularHeading(pos1, pos2, pos3)
#                    
#                    """
#                    self.brujula.setRoll(self.jugador.getHeading())
#                    """
#                    
#                    self.jugador.Avanzar(dt)
#                    self.ActualizarCamara()
#                    
#                    
#                # no hay tercer destino, final del carril
#                else:
#                    # calcula la posicion de destino como al final del carril
#                    pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
#                    pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
#                    # pos es una tupla con el inicio y final del carril
#                    pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                    
#                    # la posicion de destino es el final del carril
#                    self.jugador.setPosDestino(pos[1])
#                    self.jugador.CalcularHeading()
#                
#                    self.jugador.Avanzar(dt)  
#                    self.ActualizarCamara()
#                    
#            # no hay un destino inmediato
#            else:
#                self.jugador.Parar()
#                
#        
#                      
#        else:
#            self.jugador.Avanzar(dt)
#            #print 'Ciculacion:Movimiento', 'pos jugador', self.jugador.getPos()
#            self.ActualizarCamara()
        
#            
#        # CONTROL DEL RESTO DE VEHICULOS
#        i = 1
#        # recorriendo la lista de vehiculos
#        while i < (self.vehiculos.__len__()):
#             
#            
#            # si le vehiculo a llegado a su destino
#            if (self.vehiculos[i].HaLlegado() and (not self.vehiculos[i].EstaParado()) ):
#                
#                # determina el nodo de destino inmediato
#                #nodo_destino = self.CalcularNodoDestino(v.getNodoOrigen())
#                # calcula el nodo del siguiente salto
#                nodo_sig_destino = self.CalcularNodoDestino( self.vehiculos[i].getNodoDestino(),
#                                                             self.vehiculos[i].getNodoSigDestino() )
#                
#                # establece destino del siguiente salto
#                # actualiza el nodo_origen y nodo_sig_destino
#                self.vehiculos[i].setNodoSigDestino( nodo_sig_destino )
#                
#                # existe un destino inmediato
#                if self.vehiculos[i].getNodoOrigen() != self.vehiculos[i].getNodoDestino():
#                    
#                    # existe un tercer destino, cruce carriles.
#                    if self.vehiculos[i].getNodoDestino() != self.vehiculos[i].getNodoSigDestino():
#                        
#                        # la posicion de destino sera el cruce de carriles
#                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
#                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
#                        pos3 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoSigDestino() )
#                        
#                        # calcula la posicion de partida del vehiculo
#                        pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                        
#                        # establece como posicion de destino el cruce de carriles
#                        pos = self.CalcularCruceCarriles(pos1, pos2, pos3)
#                        self.vehiculos[i].setPosDestino(pos)
#                        self.vehiculos[i].CalcularHeading()                              
#                        
#                        self.vehiculos[i].Avanzar(dt)
#            
#                    # no hay tercer destino, final de carril
#                    else:
#                        
#                        # calcula la posicion de destino como al final del carril
#                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
#                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
#                        # pos es una tupla con el inicio y final del carril
#                        pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                        
#                        # la posicion de destino es el final del carril
#                        self.vehiculos[i].setPosDestino(pos[1])
#                        self.vehiculos[i].CalcularHeading()
#                    
#                        self.vehiculos[i].Avanzar(dt)
#            
#                # no hay destino inmediato, eliminar
#                else:
#                    self.vehiculos[i].hide()
#                    self.vehiculos[i].Parar()
#                    #self.vehiculos.pop(i)
#                    
#            # no ha llegado a su destino, continuar avanzando        
#            else:
#                # el vehiculo no ha llegado a su destino
#                self.vehiculos[i].Avanzar(dt)
#                    
#            i = i+1
#        #fin de while
              
        # para que se siga ejecutando
        return Task.cont
    
    def setRumboJugador(self,entry):
        
#        print 'setRumboJugador'
        
        if not self.jugador.EstaParado():
                
            # si hay mas de un posible sig_destino consulta la flecha
            nodo_sig_destino = self.CalcularNodoDestino( self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(),
                                                         True)
            if nodo_sig_destino.__len__() > 1:
                self.jugador.setNodoOrigen(self.jugador.getNodoDestino())
                self.jugador.setNodoDestino(self.flecha.getNodoDestino())
                # lanza la flecha a buscar el proximo cruce
                self.flecha.ProximoCruce(self.jugador.getNodoOrigen(),
                                          self.jugador.getNodoDestino())
            else:
                # establece el nuevo nodo origen
                self.jugador.setNodoOrigen(self.jugador.getNodoDestino())
                self.jugador.setNodoDestino(self.jugador.getNodoSigDestino())
    
            # si hay mas de un posible sig_destino consulta la flecha
            nodo_sig_destino = self.CalcularNodoDestino( self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(),
                                                         True)
            if nodo_sig_destino.__len__() > 1:
                self.jugador.setNodoSigDestino( self.flecha.getNodoDestino() )
            else:
                self.jugador.setNodoSigDestino( nodo_sig_destino[0] )

               
            # INSTRUCCIONES DE DIRECCION
            self.direccion_actual.node().setText('Posición: '+ self.jugador.getNodoOrigen().getWayName())
#            self.direccion_siguiente.node().setText('Destino inmediato: '+ self.jugador.getNodoDestino().getWayName())        
#            self.direccion_siguiente_salto.node().setText('Siguiente cruce: '+ self.flecha.getNodoDestino().getWayName())
            
            # existe un destino inmediato
            if self.jugador.getNodoOrigen() != self.jugador.getNodoDestino():
            
                # hay un tercer destino, cruce de carriles
                if self.jugador.getNodoDestino() != self.jugador.getNodoSigDestino():
                                        
                # origen destino y sig_destino son diferentes

                    # la posicion de destino sera el cruce de carriles
                    pos1 = self.jugador.getNodoOrigen().getPos()
                    pos2 = self.jugador.getNodoDestino().getPos()
                    pos3 = self.jugador.getNodoSigDestino().getPos()
                    
                    cruce = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                     self.jugador.getNodoDestino(), 
                                                     self.jugador.getNodoSigDestino())

                    self.jugador.setPosDestino(cruce)
                    self.jugador.Orientar()
                    
                # no hay tercer destino, final del carril
                else:
                    # calcula la posicion de destino como al final del carril
                    pos1 = self.jugador.getNodoOrigen().getPos()
                    pos2 = self.jugador.getNodoDestino().getPos()
                    # pos es una tupla con el inicio y final del carril
                    
                    # si en ese nodo solo hay camino unico la carretera esta en el centro
#                    if self.mapa.getOneWayByNodo(self.jugador.getNodoDestino()) == 'yes':
                    if self.jugador.getNodoDestino().getOneWay() == 'yes':
                        pos = pos2
                    else:
                        # establece como posicion de destino el cruce de carriles
                        pos = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                    
                    # la posicion de destino es el final del carril
                    self.jugador.setPosDestino(pos)
                    self.jugador.Orientar()
                
                    self.ActualizarCamara()
                    
            # no hay un destino inmediato
            else:
                self.NotificarLimiteMapa(None)
                          
    
    def setRumboVehiculo(self,entry):
        
        # si le vehiculo a llegado a su destino
        i = int( entry.getIntoNodePath().getName().split('_')[-1] )
        if not self.vehiculos[i].EstaParado() :
            
            # calcula el nodo del siguiente salto
            nodo_sig_destino = self.CalcularNodoDestino( self.vehiculos[i].getNodoDestino(),
                                                         self.vehiculos[i].getNodoSigDestino() )
            
            # establece destino del siguiente salto
            # actualiza el nodo_origen y nodo_sig_destino
            self.vehiculos[i].setNodoOrigen( self.vehiculos[i].getNodoDestino() )
            self.vehiculos[i].setNodoDestino( self.vehiculos[i].getNodoSigDestino() )
            self.vehiculos[i].setNodoSigDestino( nodo_sig_destino )
            
            # existe un destino inmediato
            if self.vehiculos[i].getNodoOrigen() != self.vehiculos[i].getNodoDestino():
                
                # existe un tercer destino, cruce carriles.
                if self.vehiculos[i].getNodoDestino() != self.vehiculos[i].getNodoSigDestino():
                    
                    cruce = self.CalcularCruceCarrilesNodos(self.vehiculos[i].getNodoOrigen(),
                                                     self.vehiculos[i].getNodoDestino(), 
                                                     self.vehiculos[i].getNodoSigDestino())
                    
                    self.vehiculos[i].setPosDestino(cruce)
                    self.vehiculos[i].Orientar()
                        
                    # VELOCIDAD
                    self.vehiculos[i].setVelMax(self.getVelTramo(self.vehiculos[i].getNodoOrigen(),
                                                                 self.vehiculos[i].getNodoDestino()) * \
                                                Escalas['kmh-pxs'])
        
                # no hay tercer destino, final de carril
                else:
                    
                    # calcula la posicion de destino como al final del carril
                    pos1 = self.vehiculos[i].getNodoOrigen().getPos()
                    pos2 = self.vehiculos[i].getNodoDestino().getPos()
                    
                    if self.vehiculos[i].getNodoDestino().getOneWay() == 'yes':
                        pos = pos2
                    else:
                        # establece como posicion de destino el cruce de carriles
                        pos = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                    
                    # la posicion de destino es el final del carril
                    self.vehiculos[i].setPosDestino(pos)
                    self.vehiculos[i].Orientar()
                    
                    # VELOCIDAD
                    self.vehiculos[i].setVelMax(self.getVelTramo(self.vehiculos[i].getNodoOrigen(),
                                                                 self.vehiculos[i].getNodoDestino()) * \
                                                Escalas['kmh-pxs'])
        
            # no hay destino inmediato, eliminar
            else:
                self.RehubicarVehiculo(i)
    
    def InvertirRumbo(self):
        
        print 'Circulacion:InvertirRumbo'
        
        nodo_destino = self.jugador.getNodoDestino()
        nodo_origen = self.jugador.getNodoOrigen()
        
        # calcula la distancia recorrida por el vehiculo
        pos = self.CalcularPosicionesCarriles(nodo_origen.getPos(),nodo_destino.getPos())
        
        dist = (self.jugador.getPos()-pos[0])
        
        # calcula la posicion del carril contrario
        pos = self.CalcularPosicionesCarriles(nodo_destino.getPos(),nodo_origen.getPos())
        
        # ubica el coche en la posicion del carril contrario
        posicion = pos[1]+dist
        # establece como destino desplazar el vehiculo al carril contrario
        self.jugador.setPosDestino(posicion)
        self.jugador.Orientar()
        
        # invierte origen y destino
        nuevo_origen = self.jugador.getNodoDestino()
        nuevo_destino = self.jugador.getNodoOrigen()
        self.jugador.setNodoOrigen(nuevo_origen)
        self.jugador.setNodoDestino(nuevo_destino)
        
        # rehubica la flecha de direccion
        self.flecha.ProximoCruce(self.jugador.getNodoOrigen(),self.jugador.getNodoDestino())
        
        # obtiene la lista de adyacencia evitando retroceso
        listaAdyacentes = self.jugador.getNodoDestino().getListaSiguientes(self.jugador.getNodoOrigen())
        # determina si el siguiente destino es directo o consulta la flecha
        if listaAdyacentes.__len__()>1:
            self.jugador.setNodoSigDestino(self.flecha.getNodoDestino())
        else:
            self.jugador.setNodoSigDestino(listaAdyacentes[0])
        
        # descativa el evento de colision setRumboJugador
        self.jugador.delCollDestino(self.EventosCirculacion)
        # activa el evento de colison especial para invertir el rumbo
        self.jugador.setCollDestino(self.EventosCirculacion,self.InvertirRumboFin)
        
    def InvertirRumboFin(self,entry):
        
        print 'Circulacion:InvertirRumboFin'
        
        # desactiva el evento especial de colision para invertir el rumbo
        self.jugador.delCollDestino(self.EventosCirculacion)    
        # calcula el nuevo cruce de carriles
        cruce = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                     self.jugador.getNodoDestino(), 
                                                     self.jugador.getNodoSigDestino())
        self.jugador.setPosDestino(cruce)
        self.jugador.Orientar()
        
        # activa el evento de colision setRumboJugador
        self.jugador.setCollDestino(self.EventosCirculacion,self.setRumboJugador)
        
    def ActivarInvertirRumbo(self):
        
        print 'Circulacion:ActivarInvertirRumbo'

        # solo se pueden cambiar invertir el rumbp en calles de doble sentido
        if self.jugador.getNodoDestino().getListaAdyacentes().__contains__(self.jugador.getNodoOrigen()):
            self.InvertirRumbo()
        else:
            print 'ActivarInvertirRumbo: invertir rumbo denegado'
    
    def ActivarGirarCamara(self,sentido):
        self.giroCamara = True
        self.camaraTask = taskMgr.add(self.GirarCamara,'giro_camara',extraArgs=[sentido],appendTask=True)
        self.camaraTask.last = 0
    
    def GirarCamara(self,sentido,task):
        dt = task.time - task.last
        task.last = task.time
        base.camera.setH(base.camera.getH()+sentido*25*dt)
            
        return Task.cont
    
    def DetenerGirarCamara(self):
        taskMgr.remove('giro_camara')
       
    def CentrarCamara(self):
        self.giroCamara = False
    
    def ActualizarCamara(self):
        
        # control de la posicion de la camara
        camvec = self.jugador.coche.getPos() - base.camera.getPos()
        camvec.setZ(0)
        camdist = camvec.length()
        camvec.normalize()
        dist = Escalas['m-px']*10
        if (camdist > Escalas['m-px']*dist):
            base.camera.setPos(base.camera.getPos() + camvec*(camdist-dist))
            camdist = Escalas['m-px']*dist
        elif (camdist < Escalas['m-px']*dist):
            base.camera.setPos(base.camera.getPos() - camvec*(dist-camdist))
            camdist = Escalas['m-px']*dist

        if not self.giroCamara:
            base.camera.lookAt(self.jugador.coche)
            base.camera.setP(base.camera.getP()+25)

    
    def getNodoOrigenJugador(self):
        return self.jugador.getNodoOrigen()
    
    def getNodoDestinoJugador(self):
        return self.jugador.getNodoDestino()
            
    def getPosJugador(self):
        return self.jugador.getPos()  
    
    def getHeadingJugador(self):
        return self.jugador.getHeading()  
    
    # devuelve el nombre del nodo from del vehiculo del jugador
    def getcNodePathNameJugador(self):
        return self.jugador.getcNodePathNameFrom()
    
    def AumentarVelocidad(self):
        self.jugador.setVelMax( self.velocidades_aumentar[self.jugador.getVelMax()]) 
        self.texto_velocidad.setText('Velocidad máxima: ' + \
                                     str(self.jugador.getVelMax()/Escalas['kmh-pxs']).split('.')[0])
      
    def DisminuirVelocidad(self):
        self.jugador.setVelMax( self.velocidades_disminuir[self.jugador.getVelMax()])
        self.texto_velocidad.setText('Velocidad máxima: ' + \
                                     str(self.jugador.getVelMax()/Escalas['kmh-pxs']).split('.')[0])
    
    # dados dos nodos devuelve el nombre de way al que pertenecen ambos
    def getNombreTramo(self,nodo,nodo_siguiente):
        
        for i in nodo.getListaWays():
            for j in nodo_siguiente.getListaWays():
                # busca el way en común
                if i == j:
                    return i.getName()
                
    # dados dos nodos devuelve la velocidad de way al que pertenecen ambos
    def getVelTramo(self,nodo,nodo_siguiente):
        
        for i in nodo.getListaWays():
            for j in nodo_siguiente.getListaWays():
                # busca el way en común
                if i == j and j.getTagValue('maxspeed') is not None:
                    return i.getTagValue('maxspeed')
        
    # dados dos nodos devuelve el nombre de way al que pertenecen ambos
    def getNombreTramo(self,nodo,nodo_siguiente):
        
        for i in nodo.getListaWays():
            for j in nodo_siguiente.getListaWays():
                # busca el way en común
                if i == j:
                    return i.getName()    
    
    def __del__(self):
        self.NodoCirculacion.removeNode()
        self.NodoCirculacion2d.removeNode()
        
        
"""
    # establece el valor de la variable de la tecla pulsada
    def setKey(self,bt,valor):
        
        self.keyMap[bt] = valor
        
    # segun los valores de keyMap realiza el movimiento
 
    def Movimiento(self,task):
        
        # calcula el tiempo entre dos ejecuciones de esta funcion
        elapsed = task.time - self.last
        
        #movimiento de orientacion de la camara
        # figure out how much the mouse has moved (in pixels)
        md = base.win.getPointer(0)
        x = md.getX()
        y = md.getY()
        if base.win.movePointer(0, 100, 100):
            self.heading = self.heading - (x - 100)*0.2
            self.pitch = self.pitch - (y - 100)*0.2
        if (self.pitch < -89): self.pitch = -89
        if (self.pitch >  89): self.pitch =  89
        base.camera.setHpr(self.heading,self.pitch,0)
        dir = base.camera.getMat().getRow3(1)
        elapsed = task.time - self.last
        if (self.last == 0): elapsed = 0
        if (self.keyMap["w"]):
            self.focus = self.focus + dir * elapsed*30
        if (self.keyMap["s"]):
            self.focus = self.focus - dir * elapsed*30
        base.camera.setPos(self.focus - (dir*5))
        
        
        
        # guarda el instante de tiempo en que termina la ejecucion
        self.last = task.time
        # para que se siga ejecutando en la proxima iteracion
        return Task.cont
        
"""
