# -*- coding: utf-8 -*-

#establece el tamano de pantalla
from pandac.PandaModules import loadPrcFileData
loadPrcFileData("", """win-size 1024 768
                fullscreen 1
                win-origin 50 50
                window-title Simulador de Conduccion
                undecorated 0
                show-frame-rate-meter 1
                text-encoding utf8
		""")

# DirectStart contiene los modulos de Panda3d
import direct.directbase.DirectStart
# para capturar los eventos de teclado
from direct.showbase.DirectObject import DirectObject

from pandac.PandaModules import WindowProperties

from direct.task.Task import Task

from menu import Menu
from escenario import Escenario
from escalas import Escalas

class Simulador():
    
    def __init__(self):
        
        print "Simulador"

        #  CONFIGURACION
        
        # color de fondo blanco
        base.setBackgroundColor(1,1,1)
        
        # objeto para capturar eventos
        self.Eventos = DirectObject()
        
        
        #desactiva el movimiento de teclado
        base.disableMouse()
        # para establecer propiedades de la pantalla
        props = WindowProperties()
        # oculta el cursor en la pantalla
        props.setCursorHidden(True)
        
        base.win.requestProperties(props)     

        #establece la distancia del campo visible al lejos
        base.camLens.setFar(Escalas['m-px']*100)
        base.camLens.setNear(Escalas['m-px']*4)
        # horizontal, vertical
#        base.camLens.setFov(90)
        base.camLens.setFov(80)
        
        # CREACION DE OBJETOS
        
        # objeto menu del videojuego
        self.Menu = Menu()
                
        #crea el objeto para cargar los escenarios
        self.Escenario = Escenario()
        
        # ACCIONES
        
        #muestra el menu
        self.Menu.Entrar()    
        
        # EVENTOS
        
        #evento para ir al escenario
        self.Eventos.accept('enter', self.MenuIrEscenario)
         
        #termina la ejecucion al pulsar escape
        self.Eventos.accept('escape', taskMgr.stop)
        
    
    """
     FUNCIONES PARA CONTROLAR LAS TRANSICIONES ENTRE PANTALLLAS
     desdel el objeto simulador se controla el acceso a las distintas
     partes de la aplicacion (eventos de teclado y pantalla mostrada)
    """
        
    #Existe una funcion de transicion para el cambio de una pantalla a otra
    def MenuIrEscenario(self):
       
        print "Simulador:MenuIrEscenario"
        
        # comprueba si se utilizaran coordenadas erroneas
        if self.Menu.MapaCorrecto():
            # cancela el evento para entrar en el escenario
            self.Eventos.ignore('enter')
           
            # salir del menu
            self.Menu.Salir()  
            # muestra el escenario
        
            # muestra el escenario creado
            if self.Menu.getModoMapa() == 'lista':
                self.Escenario.Entrar(self.Menu.getModoMapa(),
                                      self.Menu.getNombreMapa(),
                                      None)
            else: # mapa == 'http'
                self.Escenario.Entrar(self.Menu.getModoMapa(),
                                      self.Menu.getLatitudMapa(),
                                      self.Menu.getLongitudMapa())
            
            # evento para salir del escenario y volver a la pantalla menu
            self.Eventos.accept('control-q', self.EscenarioIrMenu)
        
    def EscenarioIrMenu(self):
        
        print "Simulador:EscenarioIrMenu"
        
        # cancela el evento para salir del escenario
        self.Eventos.ignore('control-q')
        # salir del escenario
        self.Escenario.Salir()
                
        # muestra la pantalla menu
        self.Menu.Entrar()
        #evento para ir al escenario
        self.Eventos.accept('enter', self.MenuIrEscenario)
        

# Crea el videojuego
S = Simulador()
 
#inicia la iteracion del motor grafico
run()
