﻿# -*- coding: utf-8 -*-

# DirectStart contiene los modulos de Panda3d
import direct.directbase.DirectStart

# incluye la mayoria de modulos de Panda3d
from pandac.PandaModules import NodePath

# para capturar los eventos de teclado
from direct.showbase.DirectObject import DirectObject

# para la entrada de texto
from direct.gui.DirectEntry import DirectEntry

# para poner texto e imagen en pantalla
from direct.gui.OnscreenText import OnscreenText

# para poner imagenes en pantalla
from direct.gui.OnscreenImage import OnscreenImage

# para crear un objeto texto y poder incluirlo luego en un NodePath
from pandac.PandaModules import TextNode
from pandac.PandaModules import TextFont

from pandac.PandaModules import Point3

import os,sys,re


# clase menu del juego
class Menu:
    
    
    
    def __init__(self):
        
        print "Menú"
        
        # NodePath del menu a patir del cual se crean el resto de nodos
        self.NodoMenu = NodePath('nodo_menu')
        # nodo para la seleccion de mapa por fichero
        self.NodoMapaSel = NodePath('nodo_mapas')
        # nodo para el mapa segun coordenadas
        self.NodoMapaHttp = NodePath('nodo_http')
        
        # variable local del objeto Menu para los eventos
        self.EventosMenu = DirectObject()
        
        # IMAGEN DE FONDO
        
        #imagen de fondo del menu
        self.fondo = OnscreenImage(image = "./imagenes/fondo.png", 
                              pos = (0,0,0), 
                              scale = (1.35,1,1), 
                              parent = self.NodoMenu)
        
        # FUENTES
        fontSerif = loader.loadFont('fuentes/FreeSerif.ttf')
        fontSerif.setPixelsPerUnit(60)
        
        fontSansBold = loader.loadFont('fuentes/FreeSansBold.ttf')
        fontSansBold.setPixelsPerUnit(60)
        
        # MUSICA
        
        self.musica = loader.loadSfx('./sonidos/menu.ogg')
        self.musica.setLoop(True)
        self.musica.setVolume(0.5)
        
        # MENSAJE DE ERROR
        
        textError = TextNode('texto_error')
        textError.setAlign( TextNode.ALeft )
        textError.setTextColor(1,0,0,1)
        textError.setFont(fontSerif)
        textError.setText('')
        self.error = NodePath(textError)
        self.error.reparentTo(self.NodoMenu)
        self.error.setScale( 0.05)
        """
         el segundo argumetno es necesario pero no sirve,[izq-der,0,up-down] 
         [0,0,0] -> centro de la pantalla, rangos [-1,1] 
        """
        self.error.setPos( Point3(-1.32,0,-0.97) )
        
        
        # MAPAS DESDE ARCHIVO
        
        # lista de mapas disponibles
        self.mapas = []
        # indice del mapa seleccionado
        self.mapas_indice = 0
         
        # obtiene la lista de mapas
        try:
            for m in os.listdir('./mapas/'):
                # es un mapa si el archivos tiene extension .xml o .osm
                if re.match("^.+(\.(osm|xml))$",str(m)):
                    self.mapas.append(m)
        except:
            self.mapas.append("N/D")
        
        if self.mapas.__len__() ==  0:
            self.mapas.append("N/D")
            
        
        #muestra el nombre del mapa a mostrar
        text = TextNode('texto_mapa')
        #text.setText( self.mapas[0] )
        text.setAlign( TextNode.ACenter )
        text.setTextColor(0,0,0,1)
        text.setFont(fontSansBold)
        self.etiqueta = NodePath(text)
        #textNodePath = aspect2d.attachNewNode( text )
        self.etiqueta.reparentTo(self.NodoMapaSel)
        self.etiqueta.setScale( 0.3 )
        """
         el segundo argumetno es necesario pero no sirve,[izq-der,0,up-down] 
         [0,0,0] -> centro de la pantalla, rangos [-1,1] 
        """
        self.etiqueta.setPos( Point3(0,0,-0.4) )
        
        # muestra el texto de instrucciones
        self.intrucciones = OnscreenText(text="Utilize las flechas arriba/abajo para seleccionar.\n\
Pulse 'espacio' para cambiar al modo coordenadas.\n\
Pulse 'intro' para acceder.",
                                     align=TextNode.ACenter, pos =(0,-0.65), scale=0.1,
                                     font = fontSerif,
                                     parent=self.NodoMapaSel)
        
        # muestra el numero de mapa seleccionado
        self.mapa_lbindice = OnscreenText(text="",
                                         align=TextNode.ARight,
                                         pos =(1.32,-0.97),
                                         scale=0.05,
                                         font = fontSerif,
                                         parent=self.NodoMapaSel,
                                         mayChange = True)

        # MAPA POR COORDENADAS
        
        TextLat = OnscreenText(text="Latitud:",align=TextNode.ALeft, pos=(-1.05,-0.35),
                               scale=0.15,font = fontSerif,parent=self.NodoMapaHttp)
        self.DEntryLatitud = DirectEntry(text = "" ,scale=0.1,pos = (-0.55,0,-0.35),
                                    initialText="", numLines = 1,frameColor=(1,1,1,0),
                                    width=5.5,entryFont = fontSerif,parent=self.NodoMapaHttp)
        
        TextLon = OnscreenText(text="Longitud:",align=TextNode.ALeft,pos=(0,-0.35),
                               scale=0.15,font = fontSerif,parent=self.NodoMapaHttp)
        self.DEntryLongitud = DirectEntry(text = "" ,scale=0.1,pos = (0.61,0,-0.35),
                                     initialText="", numLines = 1,frameColor=(1,1,1,0),
                                     width=5.5,entryFont = fontSerif,parent=self.NodoMapaHttp)
        
        OnscreenText(text="Escriba las coordenadas, ej: 36.533146,-6.299371.\n\
Pulse 'espacio' para volver al modo selección.\n\
Pulse 'intro' para acceder.",
                     pos=(0,-0.65 ), scale=0.1,font = fontSerif,
                     parent= self.NodoMapaHttp)
        
        # foco inicial a la caja de texto para la latitud
        self.DEntryLatitud['focus'] = 1
        
        """
        # CONFIGURACION INICIAL
        self.etiqueta.node().setText( self.mapas[ self.mapas_indice ].partition('.')[0] )
        self.mapa_lbindice.setText('Mapa '+ str(self.mapas_indice+1)+'/'+str(self.mapas.__len__()))
        self.modoMapa = 'lista'
        # inicialmente se muestra la opcion mapa desde lista
        #self.NodoMapaSel.reparentTo(self.NodoMenu)
        """
    
    # indica el tipo de mapa a utilizar
    def getModoMapa(self):
        return self.modoMapa
    
    # devuekve el nombre del mapa seleccionado
    def getNombreMapa(self):
        return self.mapas[self.mapas_indice]
        #return self.etiqueta.node().getText()
    
    def MapaCorrecto(self):
    
        if self.modoMapa == 'lista':
        
            if self.mapas[0] == '-':
                self.setError('lista')
            else:
                return True
       
        elif self.modoMapa == 'http':
            
            if re.match("^(-?[0-9]+)(\.[0-9]+)?$", self.DEntryLatitud.get()):
                if re.match("^(-?[0-9]+)(\.[0-9]+)?$",self.DEntryLongitud.get()):
                    return True
                else:
                    self.setError('http')
                    self.DEntryLatitud['focus'] = 0
                    self.DEntryLongitud['focus'] = 1
                    return False
            else:
                self.setError('http')
                self.DEntryLatitud['focus'] = 1
                self.DEntryLongitud['focus'] = 0
                return False
       
    # devuelve la latitud indicada para el mapa
    def getLatitudMapa(self):
        return self.DEntryLatitud.get()
    
    # devuelve la longitud indicada para el mapa
    def getLongitudMapa(self):
        return self.DEntryLongitud.get()
    
    # cambia del menu de seleccion de mapa a coordenadas y viceversa
    def CambiarModoMapa(self):
        
        print 'Menu:CambiarModoMapa'
        
        # cambia a modo coordenadas
        if self.modoMapa == 'lista': 
            self.NodoMapaSel.detachNode()
            
            #self.setModoMapaHttp()
            self.NodoMapaHttp.reparentTo(self.NodoMenu)
            self.modoMapa = 'http'
            
            # establece el foco a la caja de texto latitud
            self.DEntryLatitud['focus'] = 1
            self.FocoCoord = 'lat'
            # limpieza de datos anteiores
            self.DEntryLatitud.enterText('')
            self.DEntryLongitud.enterText('')
            
        # cambia a modo lista de mapas
        
        else: #self.modoMapa => 'http'
            self.NodoMapaHttp.detachNode()
            
            self.NodoMapaSel.reparentTo(self.NodoMenu)
            self.modoMapa = 'lista'
            
            self.mapas_indice = 0
            self.etiqueta.node().setText( self.mapas[ self.mapas_indice ].partition('.')[0] )
            self.mapa_lbindice.setText('Mapa '+ str(self.mapas_indice+1)+'/'+str(self.mapas.__len__()))
      
            
        self.delError()
    
    # muestra el anterior mapa de la lista 
    def MapaAnterior(self):
        
        # selecciona el mapa anteior
        self.mapas_indice = (self.mapas_indice-1) % self.mapas.__len__() 
        self.etiqueta.node().setText( self.mapas[ self.mapas_indice ].partition('.')[0] )
        self.mapa_lbindice.setText('Mapa '+ str(self.mapas_indice+1)+'/'+str(self.mapas.__len__()))
        
    # muestra el siguiente mapa de la lista
    def MapaSiguiente(self):
        
        # selecciona el siguiente mapa en la lista
        self.mapas_indice = (self.mapas_indice+1) % self.mapas.__len__()
        self.etiqueta.node().setText( self.mapas[ self.mapas_indice ].partition('.')[0] )
        self.mapa_lbindice.setText('Mapa '+ str(self.mapas_indice+1)+'/'+str(self.mapas.__len__()))
     
    # cambia el cursor sobre las cajas de coordenadas
    def CambiarFoco(self):


        if self.DEntryLatitud['focus'] == 1:
            self.DEntryLatitud['focus'] = 0
            self.DEntryLongitud['focus'] = 1

        else:
            self.DEntryLatitud['focus'] = 1
            self.DEntryLongitud['focus'] = 0
    
    # muestra un mensaje de error
    def setError(self,e):
        if e == 'lista':
            self.error.node().setText('ERROR: no hay mapas disponibles.')
            print 'ERROR: no hay mapas disponibles.'
        
        if e == 'http':
            self.error.node().setText('ERROR: coordenadas incorrectas.')
            print 'ERROR: coordenadas incorrectas.'
        
    # elimina el mensaje de error
    def delError(self):
        self.error.node().setText('')
    
    def Entrar(self):
        
        print 'Menu:Entrar'
        
        # musica
        self.musica.play()
        
        self.mapas_indice = 0
        self.etiqueta.node().setText( self.mapas[ self.mapas_indice ].partition('.')[0] )
        self.mapa_lbindice.setText('Mapa '+ str(self.mapas_indice+1)+'/'+str(self.mapas.__len__()))
        
        self.NodoMapaSel.reparentTo(self.NodoMenu)
        self.modoMapa = 'lista'
        
        # mensaje de error
        self.delError()
        
        # hace visible el menu
        self.NodoMenu.reparentTo(aspect2d)
        
        # EVENTOS

        # para seleccion el mapa
        self.EventosMenu.accept("arrow_up", self.MapaAnterior)
        self.EventosMenu.accept("arrow_down", self.MapaSiguiente)
        # cambia de un cuadro de coordenadas al otro
        self.EventosMenu.accept("tab", self.CambiarFoco)
        # cambia entre la seleccion de mapas y la entreda de coordenadas
        self.EventosMenu.accept("space", self.CambiarModoMapa)
         
    def Salir(self):
        
        print 'Menu:Salir'
        
        # cancela los eventos de teclado del menu
        self.EventosMenu.ignoreAll()
        
        #oculta el menu
        self.NodoMenu.detachNode()
        self.NodoMapaHttp.detachNode()
        self.NodoMapaSel.detachNode()
        
        # musica
        self.musica.stop()
        
